// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _LIBGDA_UIMM_DATAENTRY_H
#define _LIBGDA_UIMM_DATAENTRY_H


#include <glibmm.h>

/* libgda-uimm - a C++ wrapper for libgda-ui
 *
 * Copyright (c) 2010 libgda-uimm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <libgda-ui/gdaui-data-entry.h>
#include <glibmm/interface.h>
#include <libgdamm/datamodel.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GdauiDataEntry GdauiDataEntry;
typedef struct _GdauiDataEntryClass GdauiDataEntryClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gnome
{

namespace GdaUI
{ class DataEntry_Class; } // namespace GdaUI

} // namespace Gnome
namespace Gnome
{

// Gnome::Gda class forward declarations.
namespace Gda
{

class DataHandler;

}

namespace GdaUI
{

/** DataEntry - Data entry widget.
 * The DataEntry is an interface for widgets (simple or complex) which lets
 * the user view and/or modify a GValue.
 *
* This interface is implemented by widgets which feature data editing (usually
* composed of an editing area and a button to have some more control on the
* value being edited). The interface allows to control how the widget works
* and to query the value and the attributes of the data held by the widget.
 *
* The widget can store the original value (to be able to tell if the value has
* been changed by the user) and a default value (which will be returned if the
* user explicitly forces the widget to be set to the default value). Control
* methods allow to set the type of value to be edited (the requested type must
* be compatible with what the widget can handle), set the value (which
* replaces the currently edited value), set the value and the original value
* (the value passed as argument is set and is also considered to be the
* original value).
 *
* DataEntry widgets are normally created using the create() method.
 */


class DataEntry :
  public Glib::Interface
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef DataEntry CppObjectType;
  typedef DataEntry_Class CppClassType;
  typedef GdauiDataEntry BaseObjectType;
  typedef GdauiDataEntryIface BaseClassType;

private:
  friend class DataEntry_Class;
  static CppClassType dataentry_class_;

  // noncopyable
  DataEntry(const DataEntry&);
  DataEntry& operator=(const DataEntry&);

protected:
  DataEntry(); // you must derive from this class

  /** Called by constructors of derived classes. Provide the result of 
   * the Class init() function to ensure that it is properly 
   * initialized.
   * 
   * @param interface_class The Class object for the derived type.
   */
  explicit DataEntry(const Glib::Interface_Class& interface_class);

public:
  // This is public so that C++ wrapper instances can be
  // created for C instances of unwrapped types.
  // For instance, if an unexpected C type implements the C interface. 
  explicit DataEntry(GdauiDataEntry* castitem);

protected:
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~DataEntry();

  static void add_interface(GType gtype_implementer);

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  GdauiDataEntry*       gobj()       { return reinterpret_cast<GdauiDataEntry*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const GdauiDataEntry* gobj() const { return reinterpret_cast<GdauiDataEntry*>(gobject_); }

private:


public:
  
  /** Creates a new Gdaui::DataEntry widget, taking into account the requested entry name
   * if @a plugin_name is not <tt>0</tt> (if no entry of that name is found, then the default data
   * entry widget will be created).
   * 
   *  @a plugin_name format is interpreted as two parts: <plugin name>:<plugin options>, and
   * if the plugins has no option, then the ":<plugin options>" part may be omitted.
   * @param type A Type.
   * @param plugin_name The name of an entry plugin, or <tt>0</tt>.
   * @return A new Gdaui::DataEntry widget, _NEVER_ <tt>0</tt>.
   */
  static Glib::RefPtr<DataEntry> create(GType type, const Glib::ustring& plugin_name =  Glib::ustring());

  
  /** Sets the type of value the GdauiDataEntry will handle. The type must be compatible with what
   * the widget can handle.
   * 
   * @newin{4,2}
   * @param type The Type of the data to be displayed.
   */
  void set_value_type(GType type);
  
  /** Fetch the type of data the GdauiDataEntry handles
   * 
   * @newin{4,2}
   * @return The GType type.
   */
  GType get_value_type() const;
  
  /** Push a value into the Gdaui::DataEntry. The value parameter must either be:
   * <itemizedlist>
   * <listitem>of type GDA_TYPE_<tt>0</tt> (may be created using gda_value_new_null()) to 
   * represent a <tt>0</tt> value (SQL <tt>0</tt>), or</listitem>
   * <listitem>of type specified using set_value_type(), or</listitem>
   * <listitem><tt>0</tt> to represent an undetermined value (usually an error)</listitem>
   * </itemizedlist>
   * 
   * @newin{4,2}
   * @param value A Value, or <tt>0</tt>.
   */
  void set_value(const Glib::ValueBase& value);

  /** Push a value into the DataEntry. The value parameter must be of the type
   * specified using set_value_type().
   *
   * @param value The value to set.
   *
   * @newin{4,2}
   */
  template <class DataType>
  void set_value(const DataType& value);

  /** Fetch the value held in the DataEntry widget. If the value is set to
   * NULL, the returned value is of type GDA_TYPE_NULL. If the value is set to
   * default, then the returned value is of type GDA_TYPE_NULL or is the
   * default value if it has been provided to the widget (and is of the same
   * type as the one provided by the data entry).
   *
   * @param value A place in which to store the value.  The value must be
   * uninitialized.
   *
   * @newin{4,2}
   */
  void get_value(Glib::ValueBase& value) const;
  

  /** Fetch the value held in the DataEntry widget. If the value is set to
   * NULL, the returned value is of type GDA_TYPE_NULL. If the value is set to
   * default, then the returned value is of type GDA_TYPE_NULL or is the
   * default value if it has been provided to the widget (and is of the same
   * type as the one provided by the data entry).
   *
   * @param value A place in which to store the value.  The value must be
   * uninitialized.
   *
   * @newin{4,2}
   */
  template<class DataType>
  void get_value(DataType& value) const;

  
  /** Tests the validity of @a de's contents. The validity is a determined from:
   * <itemizedlist>
   * <listitem>the @a de widget itself if it is capable of doing it (depending on the implementation)</listitem>
   * <listitem>the results of the "contents-valid" signal which can be connected from </listitem>
   * </itemizedlist>
   * 
   * @newin{4,2}
   * @return <tt>true</tt> if @a de's contents is valid.
   */
  bool content_is_valid();

  
  /** Push a value into the GdauiDataEntry in the same way as set_value() but
   * also sets this value as the reference value.
   * 
   * @newin{4,2}
   * @param value A Value, or <tt>0</tt>.
   */
  void set_reference_value(const Glib::ValueBase& value);

  /** Push a value into the DataEntry in the same way as set_value() but
   * also sets this value as the reference value.
   *
   * @param value The value to set.
   *
   * @newin{4,2}
   */
  template <class DataType>
  void set_reference_value(const DataType& value);
  
  /** Fetch the reference value held in the GdauiDataEntry widget.
   *
   * @param value A place in which to store the value.  The value must be
   * uninitialized and should not be modified.
   *
   * @newin{4,2}
   */
  void get_reference_value(Glib::ValueBase& value) const;
  
  
  /** Tells that the current value in @a de is to be considered as the reference value
   * 
   * @newin{4,2}
   */
  void set_reference_current();

  /** Fetch the reference value held in the GdauiDataEntry widget.
   *
   * @param value A place in which to store the value.  The value must be
   * uninitialized and should not be modified.
   *
   * @newin{4,2}
   */
  template<class DataType>
  void get_reference_value(DataType& value) const;

  
  /** Sets the default value for the GdauiDataEntry which gets displayed when the
   * user forces the default value. If it is not set then it is set to type GDA_TYPE_<tt>0</tt>.
   * The value parameter must either be:
   * <itemizedlist>
   * <listitem><tt>0</tt> or of type GDA_TYPE_<tt>0</tt>, or</listitem>
   * <listitem>of type specified using set_value_type().</listitem>
   * </itemizedlist>
   * 
   * @newin{4,2}
   * @param value A Value, or <tt>0</tt>.
   */
  void set_default_value(const Glib::ValueBase& value);

  /** Sets the default value for the DataEntry which gets displayed when the
   * user forces the default value. If it is not set then it is set to type
   * GDA_TYPE_NULL.  The value parameter must be of the type specified using
   * set_value_type().
   *
   * @param value The value to set.
   *
   * @newin{4,2}
   */
  template <class DataType>
  void set_default_value(const DataType& value);

  
  /** Sets the parameters of the Gdaui::DataEntry. Only the attributes corresponding to the
   * mask are set, the other ones are ignored.
   * 
   * @newin{4,2}
   * @param attrs The attributes to set (OR'ed between them).
   * @param mask The mask corresponding to the considered attributes.
   */
  void set_attributes(Gnome::Gda::ValueAttribute attrs, Gnome::Gda::ValueAttribute mask);
  
  /** Retrieves the parameters of the GdauiDataEntry widget.
   * 
   * @newin{4,2}
   * @return The OR'ed bits corresponding to the attributes.
   */
  Gnome::Gda::ValueAttribute get_attributes() const;
  
  /** Fetch the GdaDataHandler the GdauiDataEntry is using
   * 
   * @newin{4,2}
   * @return The GdaDataHandler object.
   */
  Glib::RefPtr<Gnome::Gda::DataHandler> get_handler();
  
  /** Fetch the GdaDataHandler the GdauiDataEntry is using
   * 
   * @newin{4,2}
   * @return The GdaDataHandler object.
   */
  Glib::RefPtr<const Gnome::Gda::DataHandler> get_handler() const;
  
  /** Used for the layout of Gda::DataEntry widgets in containers: queries if @a de requires
   * horizontal or vertical expansion, depending on @a horiz
   * 
   * @newin{4,2}
   * @param horiz <tt>true</tt> to query horizontal expansion requirements, or <tt>false</tt> for vertical.
   * @return <tt>true</tt> if the widget requires expansion.
   */
  bool can_expand(bool horiz) const;
  
  /** Set if @a de can be modified or not by the user
   * 
   * @newin{4,2}
   * @param editable Set to <tt>true</tt> to have an editable data entry.
   */
  void set_editable(bool editable);
  
  /** Tells if @a de can be edited by the user
   * 
   * @newin{4,2}
   * @return <tt>true</tt> if @a de is editable.
   */
  bool get_editable() const;
  
  /** Makes @a de grab the focus for the window it's in
   * 
   * @newin{4,2}
   */
  void grab_focus();

  
  /**
   * @par Prototype:
   * <tt>void on_my_%contents_activated()</tt>
   */

  Glib::SignalProxy0< void > signal_contents_activated();

  
  /**
   * @par Prototype:
   * <tt>void on_my_%contents_modified()</tt>
   */

  Glib::SignalProxy0< void > signal_contents_modified();


  //TODO: The class declaration seems to suggest that this signal throws a
  //GError.
  //_WRAP_SIGNAL(void contents_valid(), "contents-valid", errthrow)

  
  /**
   * @par Prototype:
   * <tt>void on_my_%expand_changed()</tt>
   */

  Glib::SignalProxy0< void > signal_expand_changed();

  
  /**
   * @par Prototype:
   * <tt>void on_my_%status_changed()</tt>
   */

  Glib::SignalProxy0< void > signal_status_changed();


    virtual void set_value_type_vfunc(GType type);

    virtual GType get_value_type_vfunc() const;

    virtual void set_value_vfunc(const Glib::ValueBase& value);


  void get_value_vfunc(Glib::ValueBase& value) const;

    virtual void set_ref_value_vfunc(const Glib::ValueBase& value);


  void get_ref_value_vfunc(Glib::ValueBase& value) const;

    virtual void set_value_default_vfunc(const Glib::ValueBase& value);

    virtual void set_attributes_vfunc(Gnome::Gda::ValueAttribute attrs, Gnome::Gda::ValueAttribute mask);

    virtual Gnome::Gda::ValueAttribute get_attributes_vfunc() const;


    virtual Glib::RefPtr<Gnome::Gda::DataHandler> get_handler_vfunc() const;


    virtual bool can_expand_vfunc(bool horiz) const;

    virtual void set_editable_vfunc(bool editable);

    virtual void grab_focus_vfunc();


protected:

  
public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::
  virtual void on_contents_activated();
  virtual void on_contents_modified();
  virtual void on_expand_changed();
  virtual void on_status_changed();


};

/***************************** DataEntry *****************************/

#ifndef DOXYGEN_SHOULD_SKIP_THIS

template <class DataType>
void DataEntry::set_value(const DataType& value)
{
  typedef Glib::Value<DataType> ValueType;

  // Allow a null value.
  if(value == 0)
  {
    gdaui_data_entry_set_value(gobj(), 0);
    return;
  }

  ValueType temp;
  temp.init(ValueType::value_type());
  temp.set(value);
  this->set_value(temp);
}

template<class DataType>
void DataEntry::get_value(DataType& value) const
{
  Glib::Value<DataType> temp;
  this->get_value(temp);
  value = temp.get();
}

template<class DataType>
void DataEntry::get_reference_value(DataType& value) const
{
  Glib::Value<DataType> temp;
  this->get_reference_value(temp);
  value = temp.get();
}

template <class DataType>
void DataEntry::set_default_value(const DataType& value)
{
  typedef Glib::Value<DataType> ValueType;

  // Allow a null value.
  if(value == 0)
  {
    gdaui_data_entry_set_default_value(gobj(), 0);
    return;
  }

  ValueType temp;
  temp.init(ValueType::value_type());
  temp.set(value);
  this->set_default_value(temp);
}

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

} // namespace GdaUI

} // namespace Gnome


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Gnome::GdaUI::DataEntry
   */
  Glib::RefPtr<Gnome::GdaUI::DataEntry> wrap(GdauiDataEntry* object, bool take_copy = false);

} // namespace Glib


#endif /* _LIBGDA_UIMM_DATAENTRY_H */

